#ifndef _MOGL_H_
#define _MOGL_H_

// vlastne triedy
#include "mCamera.h"
#include "mText.h"
#include "mTexture.h"

typedef struct _material { // struktura OpenGL materialu
 GLfloat amb[4],dif[4],spe[4],amb_dif[4],emi[4];
 GLfloat shi,transp,sillum[4];
};

typedef struct _light {    // struktura OpenGL svetla
 GLfloat amb[4],dif[4],spe[4];
 GLfloat pos[4],spot[3];
};

// trieda premennych a funkcii pre pracu s OpenGL
class mOGL {
public:
 mOGL();          // konstruktor
 virtual ~mOGL(); // destruktor

 GLint ViewPort[4]; // rozmery okna

 mCamera ogl_Camera[8]; // pouzite kamery

 bool gl_initialize(void); // inicializacia OpenGL
 int gl_draw(void);        // vykreslenie OpenGL sceny
 int gl_iddle(void);       // casovo zavisla uprava objektov, resp. sceny

 // zmena stavov OpenGL stavoveho stroja -----------------------------------
 void change_PolygonMode(void);   // zmena sposobu zobrazenia objektov
 void change_PauseMotion(void);   // zap/vyp casovo zavisleho pohybu objektov
 void change_HelpOnOff(void);     // zap/vyp vypisu helpu
private:
 GLuint Cnum; // cislo pouzitej OpenGL kamery

 _material ogl_Material[8]; // pouzite materialy

 _light ogl_Light[8];       // pouzite svetla

 GLfloat StartInfoPos;                // pozicia vypisu start info
 void PrintStartInfo(char *infotext); // vypis info pocas startu aplikacie

 GLfloat MV_matrix[16]; // pre ulozenie hodnot MODELVIEW matice

 GLuint t_a,t_b,t_c; // pomocne premenne
 GLfloat p1,p2;      // pomocne premenne

 GLint ogl_State[2]; // pre zistovanie stavov OpenGL stavoveho stroja

 GLubyte lighting_onoff;  // indikator zap/vyp osvetlenia
 GLubyte help_onoff;      // indikator zap/vyp vypisu helpu
 GLubyte scene_draw_type; // pohlad na scenu
 GLubyte pause_motion;    // zastavenie casovo zavisleho pohybu objektov

 char fname[128]; // pre ulozenie retazcov (cesta k suboru)

 GLfloat v11,v12,v13;        // 1. vektor
 GLfloat v21,v22,v23;        // 2. vektor

 GLfloat light_rot; // rotacia svetla

 GLfloat pp[3];     // suradnice vrcholu
 GLfloat n[3],v[3]; // normala plochy a pomocny vektor
 GLfloat s[3],t[3]; // vektory prirastku s,t texturovacich suradnic
 GLfloat lp[4];     // poloha svetelnho zdroja

 // pusun texturovacich suradnic invertovanej bump-mapy
 void doBumps(GLfloat *n,GLfloat *pp,GLfloat *s,GLfloat *t);

 // dalsie pouzite triedy --------------------------------------------------
 mText ogl_Text;       // instancia triedy mText - praca s textom
 mTexture ogl_Texture; // instancia triedy mTexture - praca s texturou
};

#endif
